import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.accessibility.*;

public class menu_swing extends JFrame implements ActionListener {

  headPanel tp;
  menuPanel mp;
  selectPanel sp;
  bottomPanel bp;
  LoginDialog testDialog;

  public static void main(String argv[]) {
    JFrame frame = new menu_swing();

    WindowListener l = new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    };
    frame.addWindowListener(l);

    /*JLabel blank = new JLabel();
    blank.setPreferredSize(new Dimension(200, 100));
    Container contentPane = frame.getContentPane();
    contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.X_AXIS));
    contentPane.add(blank);*/

    //contentPane = frame.getContentPane();

    frame.setTitle("Dynamic Statistics");
    frame.setSize(440, 460);
    frame.setResizable(false);
    //frame.setBackground(Color.white);
    //frame.pack();
    frame.setVisible(true);
  }
  
  public menu_swing() {
    super("menu_swing");

    JMenuBar menuBar;
    JMenu dbMenu;
    JRadioButtonMenuItem rbMenuItem;

    tp = new headPanel();
    mp = new menuPanel(this);
    sp = new selectPanel();
    bp = new bottomPanel();

    Container contentPane = getContentPane();
    //contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
    contentPane.setLayout(new GridLayout(4, 0, 0, 5));
    //-contentPane.setBackground(Color.white);
    contentPane.add(tp);
    contentPane.add(mp);
    contentPane.add(sp);
    contentPane.add(bp);

    //contentPane.validate();

    menuBar = new JMenuBar();
    setJMenuBar(menuBar);

    dbMenu = new JMenu("DB selection");
    menuBar.add(dbMenu);

    JButton stopButton = new JButton("Stop");
    ButtonListener sbuttonListener = new ButtonListener();
    stopButton.addActionListener(sbuttonListener);
    stopButton.setBackground(Color.red);
    stopButton.setEnabled(false);
    menuBar.add(stopButton);

    ButtonGroup dbGroup = new ButtonGroup();
    rbMenuItem = new JRadioButtonMenuItem("Illustra");
    rbMenuItem.setSelected(true);
    dbGroup.add(rbMenuItem);
    rbMenuItem.addActionListener(this);
    dbMenu.add(rbMenuItem);
    rbMenuItem = new JRadioButtonMenuItem("Oracle");
    dbGroup.add(rbMenuItem);
    rbMenuItem.addActionListener(this);
    dbMenu.add(rbMenuItem);
  }

  public void changeArea(String area) {
    System.out.println("Change to "+area);
    ((CardLayout)sp.areaP.getLayout()).show(sp.areaP, area);
  }

  public void changeDate(String date) {
    System.out.println("Change to "+date);
    ((CardLayout)sp.dateP.getLayout()).show(sp.dateP, date);
  }

  public void actionPerformed(ActionEvent e) {
    JMenuItem source = (JMenuItem)(e.getSource());
    System.out.println(source.getText() + " is detected.");
    //LoginDialog testDialog(
    testDialog = new LoginDialog(this, "Test");
    testDialog.pack();
    testDialog.setLocationRelativeTo(this);
    testDialog.show();
    String[] s = testDialog.getValidatedText();
    if (s != null) {
      System.out.println("Congratulations! " + s[0] + " " + s[1] + " " + s[2]);
    }
    //JOptionPane.showMessageDialog(this, source.getText() + " is selected.");
    //this.outMessage("Out message is successful.");
  }

  class ButtonListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      System.out.println("Stop Button");
    }
  }

  //public void outMessage(String str) {
  //  System.out.println(str);
  //}
}

class headPanel extends JPanel {
  JTextField message;

  public headPanel() {
    System.out.println("HeadPanel");
    //-setBackground(Color.white);
    GridBagLayout gb = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(gb);

    c.fill = GridBagConstraints.BOTH;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;   
    JPanel tp = new JPanel();
    tp.setFont(new Font("TimesRoman", Font.BOLD, 38));
    Label title = new Label("Statistics");
    tp.add(title);
    gb.setConstraints(tp, c);
    add(tp);

    c.gridheight = 1;
    JPanel mp = new JPanel();
    //mp.setBorder(BorderFactory.createEtchedBorder());
    //mp.setBackground(Color.white);
    //mp.setFont(new Font("Courier", Font.PLAIN, 12));
    message = new JTextField("   Welcome to NPAC Statistics   ");
    message.setEditable(false);
    message.setBackground(Color.white);
    message.setForeground(Color.blue);
    message.setFont(new Font("Helvetica", Font.PLAIN, 12));
    message.setBorder(BorderFactory.createLoweredBevelBorder());
    mp.add(message);
    gb.setConstraints(mp, c);
    add(mp);
  }
}

class menuPanel extends JPanel {
  menu_swing parent;
  spacePanel spaceP;
  timePanel timeP;

  public menuPanel(menu_swing parent) {
    System.out.println("MenuPanel");
    this.parent = parent;
    //-setBackground(Color.white);
    setBorder(BorderFactory.createEmptyBorder(5, 50, 5, 50));
    setLayout(new GridLayout(0, 2, 40, 5));

    spaceP = new spacePanel(this);
    timeP = new timePanel(this);

    add(spaceP);
    add(timeP);
  }
}

class spacePanel extends JPanel {
  menuPanel parent;
  ButtonGroup spaceG;

  public spacePanel(menuPanel parent) {
    this.parent = parent;
    //-setBackground(Color.white);
    setLayout(new GridLayout(3,0,2,2));

    Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder spaceTitle = BorderFactory.createTitledBorder(blackline, "Field");
    spaceTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(spaceTitle);

    spaceG = new ButtonGroup();

    JRadioButton siteButton = new JRadioButton("Site", true);
    JRadioButton domainButton = new JRadioButton("Domain", false);
    JRadioButton pageButton = new JRadioButton("Page", false);

    RadioListener spaceListener = new RadioListener();

    siteButton.addActionListener(spaceListener);
    domainButton.addActionListener(spaceListener);
    pageButton.addActionListener(spaceListener);

    spaceG.add(siteButton);
    spaceG.add(domainButton);
    spaceG.add(pageButton);

    add(siteButton);
    add(domainButton);
    add(pageButton);
  }

  class RadioListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      String select;
      select = e.getActionCommand();
      System.out.println("space Button: " + select);
      parent.parent.changeArea(select);
    }
  }
}

class timePanel extends JPanel {
  menuPanel parent;
  ButtonGroup timeG;

  public timePanel(menuPanel parent) {
    this.parent = parent;
    //-setBackground(Color.white);
    setLayout(new GridLayout(2,0,2,2));

    Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder timeTitle = BorderFactory.createTitledBorder(blackline, "Period");
    timeTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(timeTitle);

    timeG = new ButtonGroup();

    JRadioButton dayButton = new JRadioButton("A Day Hourly", true);
    JRadioButton weekButton = new JRadioButton("A Week Daily", false);

    RadioListener timeListener = new RadioListener();

    dayButton.addActionListener(timeListener);
    weekButton.addActionListener(timeListener);

    timeG.add(dayButton);
    timeG.add(weekButton);

    add(dayButton);
    add(weekButton);
  }

  class RadioListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      String select;
      select = e.getActionCommand();
      System.out.println("time Button: " + select);
      parent.parent.changeDate(select);
    }
  }
}

class selectPanel extends JPanel {
  JPanel areaP;
  JPanel dateP;

  sitePanel siteP;
  domainPanel domainP;
  pagePanel pageP;

  JTextField aDate;
  JTextField fromDate;
  JTextField toDate;

  public selectPanel() {
    System.out.println("SelectPanel");
    //-setBackground(Color.white);
    setLayout(new GridLayout(2, 0, 0, 5));

    /*Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder selectTitle = BorderFactory.createTitledBorder(blackline, "Selection");
    selectTitle.setTitleJustification(TitledBorder.LEFT);
    setBorder(selectTitle);*/

    areaP = new JPanel();
    areaP.setLayout(new CardLayout());

    siteP = new sitePanel(this);
    domainP = new domainPanel(this);
    pageP = new pagePanel(this);

    areaP.add("Site", siteP);
    areaP.add("Domain", domainP);
    areaP.add("Page", pageP);
    //((CardLayout)areaP.getLayout()).show(areaP, "site");

    dateP = new JPanel();
    dateP.setLayout(new CardLayout());

    JPanel twoP;
    twoP = new JPanel();
    twoP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));
    JLabel fromMonth;
    fromMonth = new JLabel("Mar");
    fromMonth.setForeground(Color.black);
    fromDate = new JTextField(" 8", 2);
    JLabel aSpace = new JLabel("     ");
    JLabel toMonth;
    toMonth = new JLabel("Mar ");
    toMonth.setForeground(Color.black);
    toDate = new JTextField("14", 2);
    twoP.add(fromMonth);
    twoP.add(fromDate);
    twoP.add(aSpace);
    twoP.add(toMonth);
    twoP.add(toDate);

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder twoTitle = BorderFactory.createTitledBorder(empty, "Type periods");
    twoTitle.setTitleJustification(TitledBorder.CENTER);
    twoP.setBorder(twoTitle);

    JPanel oneP;
    oneP = new JPanel();
    oneP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));
    JLabel aMonth;
    aMonth = new JLabel("Mar");
    aMonth.setForeground(Color.black);
    aDate = new JTextField(" 8", 2);
    oneP.add(aMonth);
    oneP.add(aDate);

    //Border empty = BorderFactory.createEmptyBorder();
    TitledBorder oneTitle = BorderFactory.createTitledBorder(empty, "Type a date");
    oneTitle.setTitleJustification(TitledBorder.CENTER);
    oneP.setBorder(oneTitle);

    dateP.add("A Day Hourly", oneP);
    dateP.add("A Week Daily", twoP);

    add(areaP);
    add(dateP);
  }
}

class sitePanel extends JPanel {
  selectPanel parent;
  JTextField site;

  static int siteColumns = 20;

  public sitePanel(selectPanel target) {
    this.parent = target;
    //setBackground(Color.white);
    //setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder siteTitle = BorderFactory.createTitledBorder(empty, "Type a site");
    siteTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(siteTitle);

    site = new JTextField("scooter.pa-x.dec.com", siteColumns);
    add(site);
  }

  public String getCondition() {
    return site.getText();
  }
}

class domainPanel extends JPanel {
  selectPanel parent;
  JComboBox domain;
  String country = "All";

  public domainPanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder domainTitle = BorderFactory.createTitledBorder(empty, "Choose a domain");
    domainTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(domainTitle);

    domain = new JComboBox();
    domain.addItem("All");
    domain.addItem("US Educational");
    domain.addItem("US Commercial");
    domain.addItem("Network");
    domain.addItem("Canada");
    domain.addItem("United Kingdom");
    domain.addItem("Sweden");
    domain.addItem("Japan");

    ComboListener domainListener = new ComboListener();
    domain.addActionListener(domainListener);

    add(domain);
  }

  public void setCountry(String newCountry) {
    country = newCountry;
  }

  public String getCondition() {
    return country;
  }

  class ComboListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      setCountry((String)domain.getSelectedItem());
    }
  }
}

class pagePanel extends JPanel {
  selectPanel parent;
  JTextField page;
  JCheckBox prefix;
  
  static int pageColumns = 15;

  public pagePanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder pageTitle = BorderFactory.createTitledBorder(empty, "Type a page");
    pageTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(pageTitle);

    page = new JTextField("/textbook/kidsweb/", pageColumns);
    prefix = new JCheckBox("Prefix");
    add(page);
    add(prefix);
  }

  public boolean IsPrefix() {
    return prefix.isSelected();
  }

  public String getCondition() {
    return page.getText();
  }
}

class bottomPanel extends JPanel {
  barPanel barP;
  buttonPanel btP;

  public bottomPanel() {
    System.out.println("BottomPanel");
    setLayout(new GridLayout(2, 0));

    barP = new barPanel();
    btP = new buttonPanel();

    add(barP);
    add(btP);
  }
}

class barPanel extends JPanel {
  public barPanel() {
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 10));
    JLabel pBarName = new JLabel("Progress: ");
    JProgressBar pBar = new JProgressBar();
    add(pBarName);
    add(pBar);
  }
}

class buttonPanel extends JPanel {

  public buttonPanel() {
    //System.out.println("ButtonPanel");
    //-setBackground(Color.white);
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    setBorder(BorderFactory.createEmptyBorder(0, 100, 20, 100));
    setLayout(new BorderLayout());
    JButton b = new JButton("Visualize");
    //b.setAlignmentX(Component.CENTER_ALIGNMENT);

    ButtonListener vbuttonListener = new ButtonListener();

    b.setActionCommand("visualize");
    b.addActionListener(vbuttonListener);
    add(b, "Center");
  }

  class ButtonListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      System.out.println("visual Button");
    }
  }
}
